// $Id: Padma.js,v 1.1.2.1 2005/05/26 22:27:52 vnagarjuna Exp $ -->

/* ***** BEGIN LICENSE BLOCK ***** 
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Nagarjuna Venna.
 * Portions created by the Initial Developer are Copyright (C) 2005
 * by the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Nagarjuna Venna <vnagarjuna@yahoo.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

//Internal format - This is my way of expressing displeasure with the Unicode standard
//IMHO, a virama based system is complicated and unintuitive.
function Padma()
{
}

//Don't use character codes 0-64, 91-96, 123-127

//Specials
Padma.candrabindu = "\u00A0";
Padma.visarga     = "\u00A1";
Padma.pollu       = "\u00A2";
Padma.anusvara    = "\u00A3";
Padma.avagraha    = "\u00A4";
Padma.yati        = "\u00A5";   //vertical diamond filled dark (classical), sometimes asterisk
Padma.udAtta      = "\u00A6";   //this and the next 2 are vedic symbols
Padma.anudAtta    = "\u00A7";
Padma.svarita     = "\u00A8";   //equivalent of udAtta
Padma.guru        = "\u00A9";
Padma.laghu       = "\u00AA";
Padma.danda       = "\u00AB";   //comma
Padma.ddanda      = "\u00AC";   //full stop (double danda)

//digits
Padma.digit_ZERO  = "\u00B0";
Padma.digit_ONE   = "\u00B1";
Padma.digit_TWO   = "\u00B2";
Padma.digit_THREE = "\u00B3";
Padma.digit_FOUR  = "\u00B4";
Padma.digit_FIVE  = "\u00B5";
Padma.digit_SIX   = "\u00B6";
Padma.digit_SEVEN = "\u00B7";
Padma.digit_EIGHT = "\u00B8";
Padma.digit_NINE  = "\u00B9";

//Vowels
Padma.vowel_A     = "\u00BA";
Padma.vowel_AA    = "\u0041";
Padma.vowel_I     = "\u0042";
Padma.vowel_II    = "\u0043";
Padma.vowel_U     = "\u0044";
Padma.vowel_UU    = "\u0045";
Padma.vowel_R     = "\u0046";
Padma.vowel_RR    = "\u0047";
Padma.vowel_L     = "\u0048";
Padma.vowel_LL    = "\u0049";
Padma.vowel_E     = "\u004A";
Padma.vowel_EE    = "\u004B";
Padma.vowel_AI    = "\u004C";
Padma.vowel_O     = "\u004D";
Padma.vowel_OO    = "\u004E";
Padma.vowel_AU    = "\u004F";

//Consonants
Padma.consnt_KA   = "\u0050";
Padma.consnt_KHA  = "\u0051";
Padma.consnt_GA   = "\u0052";
Padma.consnt_GHA  = "\u0053";
Padma.consnt_NGA  = "\u0054";
Padma.consnt_CA   = "\u0055";
Padma.consnt_CHA  = "\u0056";
Padma.consnt_JA   = "\u0057";
Padma.consnt_JHA  = "\u0058";
Padma.consnt_NYA  = "\u0059";
Padma.consnt_TTA  = "\u005A";
Padma.consnt_TTHA = "\u0061";
Padma.consnt_DDA  = "\u0062";
Padma.consnt_DDHA = "\u0063";
Padma.consnt_NNA  = "\u0064";
Padma.consnt_TA   = "\u0065";
Padma.consnt_THA  = "\u0066";
Padma.consnt_DA   = "\u0067";
Padma.consnt_DHA  = "\u0068";
Padma.consnt_NA   = "\u0069";
Padma.consnt_PA   = "\u006A";
Padma.consnt_PHA  = "\u006B";
Padma.consnt_BA   = "\u006C";
Padma.consnt_BHA  = "\u006D";
Padma.consnt_MA   = "\u006E";
Padma.consnt_YA   = "\u006F";
Padma.consnt_RA   = "\u0070";
Padma.consnt_LA   = "\u0071";
Padma.consnt_VA   = "\u0072";
Padma.consnt_SHA  = "\u0073";
Padma.consnt_SSA  = "\u0074";
Padma.consnt_SA   = "\u0075";
Padma.consnt_HA   = "\u0076";
Padma.consnt_LLA  = "\u0077";
Padma.consnt_KSH  = "\u0078";   
Padma.consnt_RRA  = "\u0079";

//extinct consonants
Padma.consnt_TCH  = "\u007A";
Padma.consnt_TJ   = "\u007B";

//Gunimtaalu
Padma.vowelsn_AA  = "\u00C1";
Padma.vowelsn_I   = "\u00C2";
Padma.vowelsn_II  = "\u00C3";
Padma.vowelsn_U   = "\u00C4";
Padma.vowelsn_UU  = "\u00C5";
Padma.vowelsn_R   = "\u00C6";
Padma.vowelsn_RR  = "\u00C7";
Padma.vowelsn_L   = "\u00C8";
Padma.vowelsn_LL  = "\u00C9";
Padma.vowelsn_E   = "\u00CA";
Padma.vowelsn_EE  = "\u00CB";
Padma.vowelsn_AI  = "\u00CC";
Padma.vowelsn_O   = "\u00CD";
Padma.vowelsn_OO  = "\u00CE";
Padma.vowelsn_AU  = "\u00CF";
Padma.vowelsn_AILEN = "\u00FB";

//vattulu
Padma.vattu_KA    = "\u00D0";
Padma.vattu_KHA   = "\u00D1";
Padma.vattu_GA    = "\u00D2";
Padma.vattu_GHA   = "\u00D3";
Padma.vattu_NGA   = "\u00D4";
Padma.vattu_CA    = "\u00D5";
Padma.vattu_CHA   = "\u00D6";
Padma.vattu_JA    = "\u00D7";
Padma.vattu_JHA   = "\u00D8";
Padma.vattu_NYA   = "\u00D9";
Padma.vattu_TTA   = "\u00DA";
Padma.vattu_TTHA  = "\u00E1";
Padma.vattu_DDA   = "\u00E2";
Padma.vattu_DDHA  = "\u00E3";
Padma.vattu_NNA   = "\u00E4";
Padma.vattu_TA    = "\u00E5";
Padma.vattu_THA   = "\u00E6";
Padma.vattu_DA    = "\u00E7";
Padma.vattu_DHA   = "\u00E8";
Padma.vattu_NA    = "\u00E9";
Padma.vattu_PA    = "\u00EA";
Padma.vattu_PHA   = "\u00EB";
Padma.vattu_BA    = "\u00EC";
Padma.vattu_BHA   = "\u00ED";
Padma.vattu_MA    = "\u00EE";
Padma.vattu_YA    = "\u00EF";
Padma.vattu_RA    = "\u00F0";
Padma.vattu_LA    = "\u00F1";
Padma.vattu_VA    = "\u00F2";
Padma.vattu_SHA   = "\u00F3";
Padma.vattu_SSA   = "\u00F4";
Padma.vattu_SA    = "\u00F5";
Padma.vattu_HA    = "\u00F6";
Padma.vattu_LLA   = "\u00F7";
Padma.vattu_KSH   = "\u00F8";   
Padma.vattu_RRA   = "\u00F9";
Padma.vattu_TCH   = "\u00FA";
Padma.vattu_TJ    = "\u00FB";

Padma.dependentForm = function (str)
{
    if (str == Padma.vowel_A)
        return "";
    //TODO: check range
    var code = str.charCodeAt(0);
    return String.fromCharCode(code + 0x80);
}
